******************************************************************
* FastLZD v0.4c (10/2009)
* HP48/49 Compressor
* MASD Code by Yann Collet
******************************************************************

ASSEMBLE

WINDOW EQU 512
LINK_TABLE EQU (WINDOW)
LINK_TABLE_SIZE EQU ((LINK_TABLE)+1)*5
LINK_TABLE_MASK EQU (LINK_TABLE)-1
MAX_OFFSET EQU (WINDOW)

DISPATCH_TABLE EQU 1024
DISPATCH_TABLE_SIZE EQU ((DISPATCH_TABLE)+1)*5
HASH_MASK EQU (DISPATCH_TABLE)-1

MINMATCH EQU 4

FLAG_FLUSH_LITERALS EQU 10
FLAG_LITERAL_LOOP EQU 9
FLAG_BETTER_MATCH EQU 8

RPL

*****************************************************
**     Compression Code
*****************************************************
CODEM

  GOSBVL =POP#           % A.A = OSIZE ( Note : C.A & D.A modifis , D1 utilis
  R3=A.W

  GOSBVL =SAVPTR         % Save B.A, D.A, D0 & D1; dtruit C
  A=DAT1.A               % Adresse Objet
  R2=A.W

% Create Temporary Memory
  A=R3.W C=A.A
  ASR.A A+C.A            % MCompress = Source + Source/16
  LC(5)(LINK_TABLE_SIZE+30)  % Chain_link table + Margin
  A+C.A R1=A.W           % ->TMatch
  LC(5)DISPATCH_TABLE_SIZE   % Dispatch table size
		C+A.A                  % MCompress + LINK_TABLE_SIZE + Dispatch
  R4=C.W                 % TempOb Size (for WipeOut)
  GOSBVL =MAKE$N         % Creates character string in tempob area ;
                         % C.A = nibbles -> D0 = addr of body of $
                         % Note : modify A.W,B.W,C.W,D.W,R0,D0&D1

  CD0EX D1=C             % -> CString
  CR4EX.W                % C.A = TempObSize; R4=->String
  GOSBVL =WIPEOUT        % Zeroes C.A nibbles at D1; Uses A.W C.A P D1
  C=R2.W D0=C            % Init Pointer Object
  C=R4.W D1=C
  A=R1.W A+C.A           % -> TMatch
  GOSBVL =CSLW5
  C=A.A R1=C.W           % Save ->Match;->CString

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% R1 : -> Match , -> CString.Start
% R3 : -> SourceEnd
% D0 : -> Source
% D1 : -> CString
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  C=0.W R2=C.W                 % Init Uncompressed Sequence
  D=0.W                        %
  B=0.W                        %

*.WriteHeader
  LC(3)HEADER DAT1=C.X D1+3
  C=R3.W DAT1=C.A D1+5         % Object Size
  AD0EX D0=A C+A.A R3=C.W      % R3 = ->SourceEnd ; A = D0

*.StartCompression
	 ST=0.FLAG_FLUSH_LITERALS
		D0-1                         % A = D0+1
		GOTO .CompressionMainLoop

*.FlushLiterals
	 ST=1.FLAG_FLUSH_LITERALS
	 GOTO .Write_Literals

*.CheckZeroLiterals
  ?C#0.A -> .CopyLiterals 	
  GOTO .PutResultOnStack
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Compression Main Loop
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% R0.A : Save ->Source
% R1.A : ->MatchTables  ->CString.Start
% R3.A : ->SourceEnd
% R4.0 : MatchSequence
% D0 : ->Source
% D1 : ->CString
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% IN : (...)
% OUT: (...)
% Uses : 4stacks
%	     (...)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*.CompressionMainLoop

% 1) Search until a Match is found
		C=A.A                       % C = D0+1
		RSTK=C                      % Save Start of Literals
		CD1EX RSTK=C                % Save ->CString
		{ D0+1
    CD0EX D0=C A=R3.A ?C>=A.A -> .FlushLiterals
	   GOSUB .FindBestMatch      % out : A.X = MatchLength; C.A = Remaining Nibbles
				UPC }	

%2) Now, we have a Match at D0
%   No Lazy Matching	

%3) Write Literals
*.Write_Literals
		C=RSTK D1=C		               % Restore D1 ->CString
		C=RSTK                      % Start of Literals
		AD0EX                       % Current Position
		D0=C                        % Start of Literals
		C=A-C.A                     % Literals length
	 ?ST=1.FLAG_FLUSH_LITERALS -> .CheckZeroLiterals
*.CopyLiterals	
		D=C.A ST=1.FLAG_LITERAL_LOOP	
		{ LC(5)15 ?D<C.A ->{ C=D.A ST=0.FLAG_LITERAL_LOOP } D-15.A
    DAT1=C.B D1+1
	   GOSBVL =MOVEDOWN          % Copy downwards C.A nibbles from D0 to D1; Update D0 & D1
	   ?ST=1.FLAG_LITERAL_LOOP UP }
% Test end of file
	 ?ST=1.FLAG_FLUSH_LITERALS ->{ GOTO .PutResultOnStack }

%4) Write Match Sequence		
  P=5 A=R4.WP                      % Get Offset / MatchLength
  B=A.X                            % B.X = MatchLength
  C=B.X D=C.X                      % D.X = Matchlength
  ASR.WP ASR.A P=0 A=0.P ASRB.A    % A.X = Offset at Ready-to-write position
		A-8.X                            % -1
		B-"MINMATCH".X                   % - MinMatch
  LC(5)7 ?C=B.X ->{ B-1.P D-1.P }  % Exclu B.X=7 (donc Match=11)
  ?B<C.X ->{ A+B.P DAT1=A.A D1+3 } % Write Offset-Match Sequence if B.X<7
  SKELSE
  { A+7.P DAT1=A.A D1+3 B-8.X
    { LC(3)15 ?B=C.X ->{ B-1.P D-1.X }
      ?B>C.X { C=B.P } SKELSE { B-16.X }   % Maximum MatchLength ( Echelle 4-19 )
      DAT1=C.B D1+1             % Write MatchLengthCode
      C+1.P UPC }
  }

%5) Skipping Entries
	 C=D.X
	 AD0EX A+C.A D0=A D0-1            % A = D0+1

%6) Continue Compression
  GOTO .CompressionMainLoop

% Ici, on place le rsultat sur la pile
*.PutResultOnStack
  C=R1.W GOSBVL =CSRW5 C-10.A R0=C.W
  AD1EX AD0EX                  % D0 = End of CString pour =Shrink$
  GOSBVL =Shrink$
  GOVLNG =GPOverWrR0Lp

	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Find Best Match
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% IN : D0 : Current source position
%      R0 : Free ! (to save D0)
%      R1 : -> MatchTables
%      R3 : End of File
% OUT: Carry if no match
%      R4 : MatchLength / Offset
% Uses : D1 ->TestMatch
%        A.W, B.A, C.W, D.A, R0.A, P, 2stack
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*.FindBestMatch
% D0 : -> CurrentSource
% D1 : -> TestMatch

  GOSUB .AddEntryD0 RTNC       % C = ->Match ; Carry if C=0

	 D=C.A		                      % D = ->Match
		AD0EX D0=A                   % ->Source
  LC(5)MAX_OFFSET C=A-C.A      % C = MatchLimit
		?D<C.A RTY                   % Match too far => Carry
		
		CDEX.A                       % D = MatchLimit
		ST=0.FLAG_BETTER_MATCH
		R0=A.A                       % save ->Source into R0
  A=0.X A+4.P R4=A.X           % Init R4 (CurrentBestMatch)
		
		{ D1=C GOSUB .CountSequence P=0  % Carry if no better
  		% Get Next Match position
  		AD1EX                      % A = D1(CurrentMatch)
    LC(5)LINK_TABLE_MASK A&C.A % Pos MOD Link_Table_Size
				C&D.X ?A=C.X EXIT          % Avoid loops
				C=R1.A C-A.A A+A.X A+A.X C-A.A   % Pos x 5 ->MatchTables
    CD1EX                      % D1 : Position du Match
    C=DAT1.A                   % C = MatchPrcdent
	  	?C>=D.A UP                 % Tant que C(NextMatch)>D(MatchLimit), on continue
		}

		?ST=0.FLAG_BETTER_MATCH RTNYES  % Carry : No Better

% Check EOF (Matchlength must not go beyond)		
		A=R0.A C=R3.A C-A.A          % C.A = Remaining nibbles
  A=0.A A=R4.X ?A>C.A ->{       % Do not overwrite beyond ObjectSize
		  R4=C.X
		  C-"MINMATCH".X RTNC        % Less than MINMATCH -> Carry
				}
		RTNCC                        % No carry


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Count Sequence
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% IN : D0 : Source Position
%      D1 : Match Position
%      R0 : Source Position (=D0)
% OUT: Carry if no better / No Carry & ST=1.FLAG_BETTER_MATCH if better
%      R4 : MatchLength / Offset if better
%      B.A : MatchLength (max 4095)
%      !! P in unknown state : to reset !!
% Uses : A.A, B.A, C.A, P, 1stack
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*.CountSequence
  A=DAT1.A C=DAT0.A            % Compare 5 nibbles /
  ?A#C.A RTNYES                % Carry : No better / (10-17)
  B=0.A B+5.P                  % / 7 4
  D0+5                         % /
*.StartCounting
  CD1EX RSTK=C C+B.A CD1EX      % / 8 8 7 8
  { A=DAT1.A C=DAT0.A          % / 18 18
    ?A#C.A EXIT                % / (?-19)
    B+5.X D0+5 D1+5
    UP }
  {     ?A#C.P EXIT            % P=0 / (7-14)
    P=1 ?A#C.P -> .Add1        % P=1 / 2 (7-14)
    P=2 ?A#C.P -> .Add2        % P=2
    P=3 ?A#C.P -> .Add3        % P=3
       B+4.X EXITNC            % Note : c'est le max possible puisque A#C.A
*.Add3 B+3.X EXITNC
*.Add2 B+2.X EXITNC
*.Add1 B+1.X                   % / 6
    }
% Restore
 	C=RSTK D1=C                  % C=Pos, Restore D1  /  8 8
		A=R0.A D0=A                  % Restore -> Source  / 11 8
  C=A-C.A                      % Delta = D0 - D1    / 7
% Result : Not necessarily better ( if > #Fh )
  A=R4.X                       % A.X = R4.X = PreviousMatchLength
		?A>=B.X RTNYES               % Carry : No Better
% Save Result if MatchLength(B.X)>PreviousMatchLength
  CSL.A CSL.A P=5 CSL.WP       % C.3=Delta
  C=B.X R4=C.WP
  ST=1.FLAG_BETTER_MATCH
  RTN                          % No Carry => better

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Add Hash Entry (and get the first match)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% IN : D0 : Source Position
%      R1.A : -> TMatch
% OUT: carry if no match
%      C.A : -> First Match  (zero if no match)
%      update Hash tables (head and chain)
% Uses : A.A, C.A, D1
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*.AddEntryD0                  % Uses A.A, D1
% TableEntry
		C=DAT0.A
		A=C.X                       % / 6
		CSR.A CSR.A                 % / 8
  CSRB.X CSRB.X               % / 11 11
		A+C.X                       % A:[0..4095] / 6
  LC(5)HASH_MASK A&C.A        % A:[0..1023] / ? ?
  C=R1.A C+A.A A+A.X A+A.X C+A.A    % / 11 7 6 6 7
  D1=C D1+5                   % D1 = R1+5A+5 -> Match.Dispatch / 8 7
% Write New Entry
  C=DAT1.A                    % A = PrevMatch / 18
  AD0EX D0=A                  % C.A = D0 (->Source)
  DAT1=A.A
		?C=0.A RTNYES               % Donc Carry
		?A=0.X -> .BuzzySignal
*.LinkMatchChain
  CD1EX                       % D1 = PrevMatch
  LC(5)LINK_TABLE_MASK A&C.A  % A = D0 MOD 512
  C=R1.A C-A.A A+A.X A+A.X C-A.A   % Pos x 5
  CD1EX                       % D1 : Case; C = PrevMatch
  DAT1=C.A
  RTN

*.BuzzySignal
  D1=(5)  =ANNCTRL
  P=3 DAT1=C.P P=0
  GOTO .LinkMatchChain

ENDCODE

